;****************************************************************************;
;* PREDMET: Strojovo orientovane jazyky                                     *;
;* ZADANIE c.: 1                                                            *;
;* SUBOR: ZAD_1.ASM                                                         *;
;* AUTOR: Ivan Nemcovsky, par. B, kr. 11, 2. rocnik, sk. rok 2000/2001      *;
;* ------------------------------------------------------------------------ *;
;* POPIS: Napiste program, ktory nacita z klavesnice retazec znakov         *;
;* (max. 100 znakov) a podla ponukaneho menu vykona jednu z moznosti: (sk.B)*;
;* a) Vypise retazec znakov na obrazovku                                    *;
;* b) Vypise pocet cislic v retazci                                         *;
;* c) Zisti, ci sa v retazci nachadza pouzivatelom zadany znak a vypise o   *;
;*    tom spravu.                                                           *;
;* d) Najde znak s min. hodnotou a vypise tento znak                        *;
;* e) Male pismena konvertuje na velke                                      *;
;* f) Zarovna text zprava (vynecha prve medzery od konca)                   *;
;* g) Ukonci vykonavanie programu                                           *;
;* ------------------------------------------------------------------------ *;
;* TERMIN ODOVZDANIA:                                                       *;
;****************************************************************************;
ZASOBNIK    SEGMENT STACK      ; Zasobnikovy segment
            DW      64 DUP (?) ; Velkost zasobniku je 64 slov = 128 bytov
ZASOBNIK    ENDS               ; Koniec zasobnikoveho segmentu
;****************************************************************************;
DATA        SEGMENT            ; Datovy segment

; Data hlavneho menu, t.j. to co sa vypise na obrazovku
; 0ah = 10 posun na zaciatok riadku, 0dh = 13 posun na novy riadok
MENU_DATA   DB      37 DUP (196),' MENU ',37 DUP (196)
            DB      ' 1. Zadaj retazec.',0ah,0dh
            DB      ' 2. Vypis retazec.',0ah,0dh
            DB      ' 3. Vypis pocet cislic v retazci.',0ah,0dh
            DB      ' 4. Zisti pritomnost zadaneho znaku.',0ah,0dh
            DB      ' 5. Najdi znak s min. hodnotou.',0ah,0dh
            DB      ' 6. Konvertuj male pismena na velke.',0ah,0dh
            DB      ' 7. Zarovnaj text zprava.',0ah,0dh
            DB      ' 8. Ukonci program.',0ah,0dh
            DB      80 DUP (196),'$'

ZADAJ       DB      'Zadaj retazec: ','$'
VYPIS       DB      'Zadany retazec: ', '$'
UPRAVA      DB      0ah, 0dh,'Upraveny retazec: ','$'
STLAC       DB      0ah,0dh,'Stlac lubovolnu klavesu...','$'


VSTUP       DB      100        ; Max. pocet nacitanych znakov retazca
POCET       DB      0          ; Skutocny pocet nacitanych znakov retazca
            DB      101 DUP (0); Nacitane znaky + jedno miesto na znak '$'
NR          DB      0ah, 0dh, '$'; Novy riadok
VYSTUP      DB      101 DUP (0); Upraveny vystupny retazec
SKONCI      DB      '$'

CISLICE     DB      2 DUP ('0'), '$' ; Pocet cislic v retazci, max. 2 znaky
POCET_C     DB      0ah, 0dh, 'Pocet cislic v retazci je: ','$'
POCET_Z     DB      0ah, 0dh, 'Pocet znakov v retazci je: ','$'
MIN_ZN      DB      0ah, 0dh, 'Minimalny znak: ','$'
ZNAK        DB      0
UZNAK       DB      '<-','$'

ZADAJ_Z     DB      'Zadaj znak: ','$'

DATA        ENDS               ; Koniec datoveho segmentu
;****************************************************************************;
CODE        SEGMENT            ; Kodovy segment

            ASSUME  cs:CODE, ds:DATA, ss:ZASOBNIK

Start:      mov     ax, seg DATA      ; inicializuj datovy segment
            mov     ds, ax            ; ds obsahuje segmentovu adresu DATA
            mov     VSTUP+2, '$'      ; na zaciatku je nulovy retazec

Menu:       mov     ah, 00h           ; nastav textovy mod 80x25, 16 farieb
            mov     al, 03h           ; sluzi na vymazanie obrazovky
            int     10h               ; prerusenie video sluzieb

            mov     dx, offset MENU_DATA ; vypisanie hlavneho menu na obraz.
            mov     ah, 09h              ; sluzba 09h, prerusenia 21h dosu
            int     21h

Klavesa:    mov     ah, 08h              ; cakaj na stlacenie klavesy
            int     21h                  ; stlacena klavesa je vratena v al
            cmp     al, 31h              ; 31h = 49 znak '1'
            jb      Klavesa              ; ak je znak < '1' cakaj dalej
            cmp     al, 38h              ; 38h = 56 znak '8'
            ja      Klavesa              ; ak je znak > '8' cakaj dalej
            jmp     Vyber                ; skok na vyber znaku

Nacitaj_Retazec:                         ; Nacitanie retazca
            mov     ah, 09h              ; Vypisanie textu v ZADAJ
            mov     dx, offset ZADAJ     ; t.j. Zadaj retazec:
            int     21h

            mov     ah, 0ah              ; Nacitanie retazca
            mov     dx, offset VSTUP     ; do pripraveneho buffera VSTUP
            int     21h

            mov     dx, offset VSTUP     ; Do dx adresu vst. retazca
            add     dx, 2                ; + 2 prve dva byty su max a dlzka
            xor     ax, ax               ; Vynulovanie ax
            mov     al, POCET            ; Do al daj dlzku nacit. retazca
            add     dx, ax               ; posun sa dalej o dlzku
            mov     bx, dx               ; Adresuj cez bx, cez dx to nejde
            mov     byte ptr [bx], '$'   ; Pridanie znaku '$' na koniec

            jmp     Menu                 ; Spat do menu

Vypis_Retazec:                           ; Vypisanie retazca na obrazovku
            mov     ah, 09h              ; Vypise: "Zdanany retazec:"
            mov     dx, offset VYPIS
            int     21h

            mov     ah, 09h              ; Vypise zadnany retazec
            mov     dx, offset VSTUP + 2
            int     21h

            mov     ah, 09h              ; Vypise "Stlac lubovolnu klavesu..."
            mov     dx, offset STLAC
            int     21h

            mov     ah, 08h              ; Caka na stlacenie klavesy
            int     21h

            jmp     Menu                 ; Vrat sa spat do menu

Pocet_Cislic:                            ; Zistenie poctu cislic v retazci
            mov     bx, offset VSTUP + 2
            xor     ax, ax               ; Nulovanie ax
            xor     cx, cx               ; Nulovanie cx
            mov     cl, POCET            ;
            cmp     cx, 0                ; cx obsahuje dlzku retazca
            je      Ziadne_Cislice       ; ak je retazec nulovy nema cislice
Cyklus_1:
            mov     ah, [bx]             ; daj do ah znak v retazci
            cmp     ah, 30h              ; cislice su od 30h do 39h
            jb      Nie_je_cislica       ; ak je ah < 30h nie je to cislica
            cmp     ah, 39h              ; ak je ah > 39h nie je to cislica
            ja      Nie_je_cislica       ;
            inc     al                   ; ak je ah cislica zvys al o 1
Nie_je_cislica:
            inc     bx                   ; posun sa v retazci
            loop    Cyklus_1             ; zopakuj cyklus ak nie sme na konci

            xor     ah, ah               ; ax obsahuje pocet cislic v retazci
            mov     bl, 10               ; vydel ax 10
            div     bl                   ;
            add     al, 30h              ; al obsahuje podiel
            add     ah, 30h              ; ah obsahuje zvysok
            ; pridaj k cislam 30h aby boli znakove cisla
            mov     CISLICE, al          ; poskladaj z cisel retazec
            mov     CISLICE+1, ah        ; reprezentujuci cely pocet
Ziadne_Cislice:
            mov     ah, 09h              ; Vypise: "Zadany retazec:"
            mov     dx, offset VYPIS
            int     21h

            mov     ah, 09h              ; Vypise zadany retazec
            mov     dx, offset VSTUP + 2
            int     21h

            mov     ah, 09h              ; Vypise: "Pocet cislic v retazci je:"
            mov     dx, offset POCET_C
            int     21h

            mov     ah, 09h              ; Vypise pocet cislic
            mov     dx, offset CISLICE
            int     21h

            mov     ah, 09h              ; Vypise: "Stlac lub. klavesu..."
            mov     dx, offset STLAC
            int     21h

            mov     ah, 08h              ; Caka na stlacenie klavesy
            int     21h

            mov     CISLICE, '0'         ; Vynuluj retazec obsahujuci
            mov     CISLICE+1, '0'       ; pocet cislic

            jmp     Menu                 ; Spat do menu

Pritomnost_Znaku:                        ; Zistenie pritomnosti znaku v retaz.

            mov     ah, 09h              ; Vypise: "Zadaj znak:"
            mov     dx, offset ZADAJ_Z
            int     21h

            mov     ah, 01h              ; Caka na stlacenie klavesy
            int     21h

            mov     ah, al               ; daj do ah znak v al
            xor     al, al               ; nuluj al
            mov     bx, offset VSTUP + 2 ; bx - zaciatok retazca
            xor     cx, cx               ; nuluj cx
            mov     cl, POCET            ; cx obsahuje dlzku retazca
            cmp     cx, 0                ; ak je retazec nulovy nema
            je      Ziadne_Znaky         ; ziadne znaky
Hladaj:
            cmp     [bx], ah             ; porovnaj znak v retazci so stl.
            jne     Nie_je               ; znakom, ak sa nerovnaju chod dalej
            inc     al                   ; ak sa rovnaju zvys al o 1
Nie_je:
            inc     bx                   ; posun v retazci dalej
            loop    Hladaj               ; ak nie si na konci opakuj cyklus

            xor     ah, ah               ; nuluj ah, ax obsahuje pocet znakov
            mov     bl, 10               ; del ax 10
            div     bl
            add     al, 30h              ; al obsahuje podiel
            add     ah, 30h              ; ah obsahuje zvysok

            mov     CISLICE, al          ; vytvor retazec obsahujuci pocet
            mov     CISLICE+1, ah        ; znakov
Ziadne_Znaky:
            mov     ah, 09h              ; odriadkuje
            mov     dx, offset NR
            int     21h

            mov     ah, 09h              ; Vypise: "Zadany retazec:"
            mov     dx, offset VYPIS
            int     21h

            mov     ah, 09h              ; Vypise zadany retazec
            mov     dx, offset VSTUP + 2
            int     21h

            mov     ah, 09h              ; Vypise: "Pocet znakov v retazci je:"
            mov     dx, offset POCET_Z
            int     21h

            mov     ah, 09h              ; Vypise pocet znakov v retazci
            mov     dx, offset CISLICE
            int     21h

            mov     ah, 09h              ; Vypise: "Stlac lub. klavesu..."
            mov     dx, offset STLAC
            int     21h

            mov     ah, 08h              ; Caka na stlacenie klavesy
            int     21h

            mov     CISLICE, '0'         ; Vynuluje retazec obsahujuci pocet
            mov     CISLICE+1, '0'       ; znakov

            jmp     Menu                 ; Spat do menu

Min_Znak:                                ; Zisti min. znak v retazci
            mov     ah, 09h              ; Vypise: "Zadnay retazec:"
            mov     dx, offset VYPIS
            int     21h

            mov     ah, 09h              ; Vypise zadany retazec
            mov     dx, offset VSTUP + 2
            int     21h

            mov     bx, offset VSTUP + 2 ; bx ukazuje na zac. retazca
            xor     cx, cx               ; nuluj cx
            mov     cl, POCET            ; cx obsahuje dlzju retazca
            xor     al, al               ; nuluj al
            cmp     cx, 0                ; ak je cx 0 tak retazec je nulovy
            je      Nie_Je_Min           ; a nema min. znak
            mov     al, [bx]             ; daj do al znak z retazca
            dec     cx                   ; zniz cx o 1
            inc     bx                   ; posun v retazci o 1
Hladaj_Min:
            cmp     al, [bx]             ; porovnaj znak v al so znakom v [bx]
            jbe     Je_Mensi             ; je znak v retazci mensi ako v al ?
            mov     al, [bx]             ; ano je tak daj do al mensi znak
Je_Mensi:
            inc     bx                   ; posun v retazci o 1
            loop    Hladaj_Min           ; opakuj cyklus
Nie_Je_Min:
            mov     ZNAK, al             ; uloz min znak v premennej ZNAK

            mov     ah, 09h              ; Vypise: "Minimalny znak je:"
            mov     dx, offset MIN_ZN
            int     21h

            mov     ah, 02h              ; Vypise min. znak
            mov     dl, ZNAK
            int     21h

            mov     ah, 09h              ; Vypise: "Stlac lub.klavesu..."
            mov     dx, offset STLAC
            int     21h

            mov     ah, 08h              ; Caka na stlacenie klavesy
            int     21h

            jmp     Menu                 ; Spat do menu

Konvertuj:                               ; Konvertuj male pis. na velke
            mov     bx, offset VSTUP + 2 ; bx ukazuje na zac.retazca
            mov     si, offset VYSTUP    ; si ukazuje na vystup
            xor     cx, cx               ; nuluj cx
            mov     cl, POCET            ; cx obsahuje dlzku retazca
            cmp     cx, 0                ; ak je cx = 0  tak retazec je nul.
            je      Nekonvertuj          ; a netreba nic konvertovat
Zmena:
            mov     al, [bx]             ; daj do al znak z retazca
            cmp     al, 97               ; ak je al < 97 a > 122 tak to nieje
            jb      Nie_je_male          ; male pismeno a netreba ho konvert.
            cmp     al, 122
            ja      Nie_je_male
            sub     al, 32               ; v al je male pis. tak odrataj 32
Nie_je_male:                             ; cim ho zmenis na velke
            mov     byte ptr [si], al    ; skopiruj znak z vstupu na vystup
            inc     bx                   ; posun sa vo vstupe
            inc     si                   ; posun sa vo vystupe
            loop    Zmena                ; opakuj cyklus

            mov     byte ptr [si + 1], '$' ; ukonci vystup ukonc. znakom

            mov     ah, 09h              ; Vypise: "Zadany retazec"
            mov     dx, offset VYPIS
            int     21h

            mov     ah, 09h              ; Vypise zadany retazec
            mov     dx, offset VSTUP + 2
            int     21h

            mov     ah, 09h              ; Vypise: "Upraveny retazec:"
            mov     dx, offset UPRAVA
            int     21h

            mov     ah, 09h              ; Vypise zkonvertovany retazev
            mov     dx, offset VYSTUP
            int     21h

            mov     ah, 09h              ; Vypise: "Stlac lub. klavesu..."
            mov     dx, offset STLAC
            int     21h

            mov     ah, 08h              ; Caka na stlacenie klavesy
            int     21h
Nekonvertuj:
            jmp     Menu                 ; Spat do menu

Zarovnaj:
            xor     cx, cx               ; Nuluj cx
            mov     cl, POCET            ; cx obsahuje dlzku retazca
            cmp     cx, 0                ; ak je cx 0 tak je ratazec nulovy
            je      Nezarovnaj           ; a nieje co zarovnavat

            mov     bx, offset VSTUP + 2 ; bx ukazuje na zac. retazca
            mov     si, offset VYSTUP    ; si ukazuje na vystupny retazec
Kopiruj:
            mov     al, [bx]             ; al obsahuje znak vst. retazca
            mov     [si], al             ; skopiruj al do vystup. retazca
            inc     bx                   ; posun sa v retazci o 1
            inc     si                   ; posun sa vo vystup. retazci o 1
            loop    Kopiruj              ; Kopiruj do konca
            mov     byte ptr [si], '$'   ; Ukonci vyst. retazec '$'

; !!! Ak retazec obsahuje znak '$' tak zarovnanie prebehne na retazci spravne
; ale sluzba dosu ah, 09h vypise povodny retazec a aj upraveny retazec len po
; tento znak '$' a tym padom na obrazovke vidime nieco ine ako je vskutocnosti
; najviac to metie ak je su pred tymto znakom medzery, tieto sa nevymazu a zostavaju
; v retazci a su aj sluzbou zobrazene t.j. to vyzera akoby sa retazec vobec
; nezarovnal, ak pred tymto znakom niesu medzery vyzera zase este aj povodny 
; retazec zarovnany

            xor     cx, cx               ; Nuluj cx
            mov     cl, POCET            ; cx obsahuje dlzku retazca
            dec     si                   ; zniz si o 1 aby ukazovalo na posl.
Zarovnavaj:                              ; znak vyst. retazca
            mov     al, [si]             ; daj do al znak z vyst. retazca
            cmp     al, 20h              ; je v al ' ' ?
            jne     Ziadna_zmena         ; nie je tak nic nerob
            mov     byte ptr [si], '$'   ; je tak vymen za ukonc. znak '$'
            dec     si                   ; posun v retazci smerom k zaciatku
            loop    Zarovnavaj           ; Ak nie si na konci opakuj cyklus
Ziadna_zmena:
            mov     ah, 09h              ; Vypise: "Zadny retazec:"
            mov     dx, offset VYPIS
            int     21h

            mov     ah, 09h              ; Vypise zadany retazec
            mov     dx, offset VSTUP + 2
            int     21h

            mov     ah, 09h              ; Vypise: "<--"
            mov     dx, offset UZNAK
            int     21h

            mov     ah, 09h
            mov     dx, offset UPRAVA    ; Vypise: "Upraveny retazec:"
            int     21h

            mov     ah, 09h              ; Vypise zkonvertovany retazec
            mov     dx, offset VYSTUP
            int     21h

            mov     ah, 09h              ; Vypise: "<--"
            mov     dx, offset UZNAK
            int     21h

            mov     ah, 09h              ; Vypise: "Stlac lub. klavesu..."
            mov     dx, offset STLAC
            int     21h

            mov     ah, 08h              ; Caka na stlacenie klavesy
            int     21h
Nezarovnaj:
            jmp     Menu                 ; Spat do menu

Vyber:      cmp     al, 31h              ; je v al '1' ?
            jne     Dalsi_1
            jmp     Nacitaj_Retazec      ; Bola stlac. '1': Nacitaj retazec
Dalsi_1:
            cmp     al, 32h              ; je v al '2' ?
            jne     Dalsi_2
            jmp     Vypis_Retazec        ; Bola stlac '2': Vypis retazec
Dalsi_2:
            cmp     al, 33h              ; je v al '3' ?
            jne     Dalsi_3
            jmp     Pocet_Cislic         ; Bola stlac '3': Zisti pocet cislic
Dalsi_3:
            cmp     al, 34h              ; je v al '4' ?
            jne     Dalsi_4
            jmp     Pritomnost_Znaku     ; Bola stlac. '4': Najdi znak
Dalsi_4:
            cmp     al, 35h              ; je v al '5' ?
            jne     Dalsi_5
            jmp     Min_Znak             ; Bola stlacena '5': Najdi min. znak
Dalsi_5:
            cmp     al, 36h              ; je v al '6' ?
            jne     Dalsi_6
            jmp     Konvertuj            ; Bola stlacena '6': Koncertuj pismena
Dalsi_6:
            cmp     al, 37h              ; je v al '7' ?
            jne     Dalsi_7
            jmp     Zarovnaj             ; bola stlacena '7': Zarovnaj ret.
Dalsi_7:
            cmp     al, 38h              ; je v al '8' ?
            jne     Spat_do_Menu
            jmp     Koniec               ; Bola stlacena '8': skonci
Spat_do_Menu:
            jmp     Menu                 ; Spat do menu

Koniec:     mov     ax, 4c00h            ; Vratenie kontroly Dosu
            int     21h

CODE        ENDS               ; Koniec kodoveho segmentu
            END     Start      ; Koniec programu
;****************************************************************************;
;* Program je funkcny. Chova sa nahodne pri zarovnavani retazca.            *;
;* Zarovnanie zprava znamena: vynechanie vsetkych medzier v retazci zprava  *;
;* t.j. vymaze medzery na konci                                             *;
;* v editore Volcov Commander, a pod. turbo assemblerom verzie: TASM 3.1    *;
;* Pouzity linker: TLINK 5.1                                                *;
;* Program vyuziva sluzby DOSU (Int 21h), BIOSU (Int 10h)                   *;
;* Program je mozne este vylepsit a to pouzitim procedur, retazcovych instr.*;
;* Finty: nulovanie registra pomocou xor: xor ax, ax                        *;
;* Obmedzenia: Retazec nemoze obsahovat znak '$', inak sa vypise len po     *;
;* tento znak. Je to ukoncivaci znak pouzitych sluzieb dosu.                *;
;****************************************************************************;