;******************************************************************************;
;* PREDMET    : Strojovo orientovane jazyky                                   *;
;* ZADANIE C. : 2                                                             *;
;* SUBOR      : ZAD2.ASM                                                      *;
;* AUTOR      : Ivan Nemcovsky, par. B, kr. 11, 2. rocnik sk. rok 2000/2001   *;
;* -------------------------------------------------------------------------- *;
;* POPIS:                                                                     *;
;* -------------------------------------------------------------------------- *;
;* Vytvorte program, ktory nacita z textoveho suboru postupnost celych        *;
;* cisel (aspon 10) so znamienkom v desiatkovej ciselnej sustave, potom ich   *;
;* transformuje na cisla v dvojkovej ciselnej sustave v doplnkovom kode       *;
;* a potom podla priania pouzivatela (skupina B):                             *;
;* a) spocita kladne alebo zaporne cisla a sumu vypise                        *;
;* b) usporiada cisla zostupne a zapise usporiadanu postupnost cisel do       *;
;*    noveho textoveho suboru                                                 *;
;* c) vydeli dve vybrane cisla a vypise vysledok                              *;
;* d) vynasobi posledne dve cisla a vypise vysledok                           *;
;* e) ukonci vykonavanie programu                                             *;
;* -------------------------------------------------------------------------- *;
;* TERMIN ODOVZDANIA:                                                         *;
;******************************************************************************;
.286
;******************************************************************************;
ZASOBNIK    SEGMENT STACK
            DW      64 DUP (?)
ZASOBNIK    ENDS
;******************************************************************************;
DATA        SEGMENT

Menu_Data   DB      218, 36 DUP (196)," MENU ", 36 DUP (196), 191
            DB      179, " 1. Spocitaj kladne cisla     ", 48 DUP (' '), 179
            DB      179, " 2. Spocitaj zaporne cisla    ", 48 DUP (' '), 179
            DB      179, " 3. Usporiadaj cisla zostupne ", 48 DUP (' '), 179
            DB      179, " 4. Vydel dve vybrane cisla   ", 48 DUP (' '), 179
            DB      179, " 5. Vynasob dve posledne cisla", 48 DUP (' '), 179
            DB      179, " 6. Ukonci program            ", 48 DUP (' '), 179
            DB      192, 78 DUP (196), 217
            DB      "> Nacitana postupnost cisel: ", '$'

Chyba_vst   DB      "Chyba! Vstupny subor neexistuje alebo je prazdny.", '$'

Vstup       DB      'ZAD2.IN' , 0     ; Vstupny subor
Vystup      DB      'ZAD2.OUT', 0     ; Vystupny subor
Handle      DW      0                 ; Handle prave otvoreneho suboru
Dlzka       DW      0                 ; Dlzka vst. suboru resp. buffera
Nacitane    DB      80 DUP (?)        ; Buffer obsahujuci udaje vst. suboru
Zapisane    DB      80 DUP (?)        ; Buffer obsahujuci uspor. udaje
                                      ; vo vypisatelnej podobe
Cisla       DB      10 DUP (0)        ; Dekodovany buffer, t.j. uz cisla
                                      ; v dvojkovom kode
Cisla_MAX   DB      10 DUP (0)        ; Usporiadana postupnost cisel

Pocet       DB      0                 ; Pocet nacitanych cisel

Cislo       DB      '.', 5 DUP (0)    ; Jedno cislo z nacit. cisel
Znamienko   DB      0                 ; Znamienko pri cisle: 0(+), 1(-)

Sucet_Kl    DB      0Ah, 0Dh, "> Sucet kladnych cisel: ", '$'
Sucet_Zp    DB      0Ah, 0Dh, "> Sucet zapornych cisel: -", '$'
Pretecenie  DB      0Ah, 0Dh, "> Doslo k preteceniu! Uvazovana mnozina cisel je <-128,127>", '$'
Podtecenie  DB      0Ah, 0Dh, "> Doslo k podteceniu! Uvazovana mnozina cisel je <-128,127>", '$'
Usporiadane DB      0Ah, 0Dh, "> Usporiadane cisla: ", '$'

Nasobene    DB      0Ah, 0Dh, "> Posledne dve cisla vynasobene: ", '$'

Zvol_1      DB      0Ah, 0Dh, "> Zvolit cislo znamena stlacit klavesu 0 az 9."
            DB      0Ah, 0Dh, "> Zvol prve cislo: ", '$'
Zvol_2      DB      0Ah, 0Dh, "> Zvol druhe cislo: ", '$'
Podiel_1    DB      0Ah, 0Dh, "> Podiel: ", '$'
Podiel_2    DB      " / ", '$'
Podiel_3    DB      " = ", '$'
Podiel_4    DB      " , Zvysok: ", '$'

DATA        ENDS
;******************************************************************************;
CODE        SEGMENT
            ASSUME  cs:CODE, ds:DATA, es:DATA, ss:ZASOBNIK
;------------------------------------------------------------------------------;
;                                  Hlavny program                              ;
;------------------------------------------------------------------------------;
Start:      mov     ax, seg DATA      ; Inicializuj datovy segment
            mov     ds, ax            ; DS aj ES obsahuju seg. adresu
            mov     es, ax            ; datoveho segmentu

            call    Nacitaj           ; Zavolaj podprogram, ktory nacita
                                      ; udaje zo vst. suboru
            call    Dekoduj           ; Dekoduje vst. buffer na cisla
                                      ; v dvojkovej sustave

Menu:       mov     ah, 02h            ; Nastav kurzor na poziciu [0,0]
            mov     bh, 0              ; na obrazovke t.j. lavy horny roh
            xor     dx, dx
            int 10h

            mov     ah, 07h            ; Posun obraz o 25 riadkov dole
            xor     cx, cx             ; Simuluje vymazanie obrazovky
            mov     dh, 24
            mov     dl, 79
            mov     al, 25
            mov     bh, 7
            int     10h

            mov     ah, 09h           ; Vypis Menu na obrazovku
            mov     dx, offset Menu_Data
            int     21h

            cmp     Dlzka, 0          ; Ak je Dlzka nacit. udajov = 0
            je      Chyba_vst_suboru  ; tak bud vst. ubor neexistuje alebo
                                      ; je nulovy
            mov     bx, offset Nacitane ; Predanie parametrov podprogramu
            push    bx                ; Vypis pomocou zasobniku
            mov     bx, Dlzka         ; Dlzka - 1 lebo posledny znak
            dec     bx                ; je ',' a ten nechcem vypisat
            push    bx
            call    Vypis             ; Vypis nacitane udaje

Vyber:      mov     ah, 08h           ; Caka na stlacenie klavesy
            int     21h
            cmp     al, 31h           ; Bola stlacena cislica ?
            jb      Vyber
            cmp     al, 36h
            ja      Vyber
                                      ; Ano bola stlacena cislica
            cmp     al, 31h           ; Je to '1' ?
            jne     Dalsi_1
            call    Kladne            ; Je to '1' za volaj podprogram Kladne
            jmp     Menu
Dalsi_1:
            cmp     al, 32h           ; Je to '2' ?
            jne     Dalsi_2
            call    Zaporne           ; Je to '2' za volaj podprogram Zaporne
            jmp     Menu
Dalsi_2:
            cmp     al, 33h           ; Je to '3' ?
            jne     Dalsi_3
            call    Max_Sort          ; Je to '3' za volaj podprogram Max_Sort
            jmp     Menu
Dalsi_3:
            cmp     al, 34h           ; Je to '4' ?
            jne     Dalsi_4
            call    Delenie           ; Je to '4' za volaj podprogram Delenie
            jmp     Menu
Dalsi_4:
            cmp     al, 35h           ; Je to '5' ?
            jne     Dalsi_5
            call    Nasob_Posl        ; Je to '5' za volaj podprogram Nasob_Posl
            jmp     Menu
Dalsi_5:
            cmp     al, 36h           ; Je to '6' ?
            je      Koniec            ; Skok na koniec programu
            jmp     Menu

Chyba_vst_suboru:
            mov     ah, 09h           ; Vstupny subor neexistuje alebo
            mov     dx, offset Chyba_vst ; je prazdny
            int     21h
Koniec:
            mov     ax, 4c00h         ; Vratenie kontroly DOSu
            int     21h
;------------------------------------------------------------------------------;
;                                   Podprogramy                                ;
;------------------------------------------------------------------------------;
Nacitaj     PROC    NEAR

            mov     ah, 3dh           ; Otvor vstupny subor pre citanie
            mov     al, 0
            mov     dx, offset Vstup
            int     21h

            jc      Neexistuje        ; Ak neexistuje tak skonci
            mov     Handle, ax        ; Ak existuje zapamataj si handle

            mov     ah, 42h           ; Zisti velkost vstupneho suboru
            mov     bx, Handle        ; posunom na jeho koniec
            xor     cx, cx            ; Pozicia = Koniec suboru + CX:DX
            xor     dx, dx
            mov     al, 2             ; Posun v subore od konca
            int     21h

            mov     Dlzka, ax         ; Uloz velkost suboru do Dlzka

            mov     ah, 42h           ; Nastav sa na zac. vst. suboru
            mov     bx, Handle        ;
            xor     cx, cx            ; Pozicia = Zac. suboru + CX:DX
            xor     dx, dx
            mov     al, 0             ; Posun od zaciatku suboru
            int     21h

            mov     bx, Handle        ; Handle vst. suboru
            mov     cx, Dlzka         ; Pocet citanych bytov
            mov     dx, offset Nacitane ; Offset kam sa bude zapisovat
            mov     ah, 3fh
            int     21h               ; Nacitane udaje su na DS:DX = Nacitane

            mov     ah, 3eh           ; Zavri vstupny subor
            mov     bx, Handle
            int     21h
Neexistuje:
            ret                       ; Navrat do hlavneho programu

Nacitaj     ENDP
;------------------------------------------------------------------------------;
Dekoduj     PROC    NEAR              ; Podprogram, kt. prevedie nacitany
                                      ; retazec na cisla
            mov     si, offset Nacitane ; Nacitany retazec
            mov     di, offset Cisla    ; Prevedeny retazec na cisla
            mov     bx, offset Cislo + 1 ; Pomocny byffer na 1 cislo
            mov     cx, Dlzka         ; Dlzka nacitaneho retazca

Konaj:      mov     al, [si]          ; Daj do al znak z retazca
            cmp     al, ','           ; Ak je to ',' tak sme za cislom
            jne     Som_v_cisle       ; inak sme v cisle

            push    di                ; Predanie parametrom podprogramu Vytvor
            dec     bx                ; cez zasobnik
            push    bx
            call    Vytvor            ; Zavolanie podprogramu, kt. vytvori 
            inc     Pocet             ; jedno cislo, zvys pocet nacit. cisel
            inc     di                ; Posun sa v cislach o jedna
            mov     bx, offset Cislo + 1 ; Nastav bx na zac. pom. buffera
            mov     Znamienko, 0      ; Znamienko nastav na plus
            jmp     Pokracuj          ; Pokracuj dalej v retazci

Som_v_cisle:                          ; Sme v cisle
            cmp     al, '-'           ; Ak je al = '-' tak nastav znam. na minus 
            jne     Som_v_cifre       ; ak al != '-' tak sme v cifrach
            mov     Znamienko, 1      ; Nastav znamienko na minus
            jmp     Pokracuj          ; Pokracuj dalej v retazci
Som_v_cifre:
            mov     [bx], al          ; al je cislica tak daj al do pom.
            inc     bx                ; a posun sa v pom. buffery
Pokracuj:
            inc     si                ; Posun sa v retazci o jedna
            loop    Konaj             ; Opakuj prevod
Hotovo:
            ret                       ; Navrat na miesto volania

Dekoduj     ENDP
;------------------------------------------------------------------------------;
Vytvor      PROC    NEAR              ; Podprogram vytvori jedno cislo
                                      ; z ascii reprez. do bin. reprez.
Odkial      EQU     [bp+4]            ; Odkial citam ascii reprez. cisla
Kam         EQU     [bp+6]            ; Kam zapisujem preved. cislo

            push    bp                ; Pre pracu s parametrami
            mov     bp, sp             
            pusha                     ; Ulozenie neskor modifikovanych regist.

            mov     bl, 10            ; Neskor budeme delit desiatimy
            mov     si, Odkial        ; Nastav si na buffer obsah. ascii reprez
            mov     di, Kam           ; Nastav di na vystupny buffer

Tvor_cislo: xor     ax, ax            ; Nuluj ax
            mov     al, [si]          ; Daj do al znak zo vst. buffera
            cmp     al, '.'           ; Je al = '.' ak ano sme na zac. buffera
            je      Vytvorene         ; a cislo je uz vytvorene
            sub     al, 30h           ; Al musi byt cislica prevedme znak na cislo

            mov     cx, Odkial        ; Daj do cx offset vst. buffera a odcitaj 
            sub     cx, si            ; od cx akt. poziciu v stupnom buffery
            cmp     cx, 0             ; ak je cx = 0 tak sme na mieste jednotiek
            je      Nenasob           ; a nenasobime 10 ani 100, atd.
Nasob:
            mul     bl                ; Sme na mieste desiatok alebo stoviek
            loop    Nasob             ; tak podla toho krat  nasobime al 10
Nenasob:
            add     [di], ax          ; K uz preved. casti cis. pripocitame
            dec     si                ; dalsiu prevedenu cast a posunieme sa
            jmp     Tvor_cislo        ; vo vst. buffery o jedna spat
Vytvorene:
            cmp     Znamienko, 1      ; Ak bolo znamienko - tak 
            jne     Kladne_cislo      ; Znamienko je plus je to kladne cislo
            neg     byte ptr [di]     ; znegujeme vytvorene cislo
Kladne_cislo:
            popa                      ; Obnov registre na povodny obsah
            pop     bp                ; Obnov bp
            ret     4                 ; Navrat na miesto volania s vymaz. param.

Vytvor      ENDP
;------------------------------------------------------------------------------;
Vypis       PROC    NEAR

Kolko       EQU     [bp+4]            ; Kolko bytov sa vypise
Odkial      EQU     [bp+6]            ; Offset odkial sa citaju udaje

            push    bp
            mov     bp, sp

            mov     cx, Kolko         ; CX obsahuje pocet vypisovanych bytov
            mov     bx, Odkial        ; BX obsahuje offset udajov

Cyklus:     mov     dl, [bx]          ; DL obsahuje znak v [BX]
            mov     ah, 02h           ; Vypis znak v DL
            int     21h
            inc     bx
            loop    Cyklus            ; Opakuj cyklus

            pop     bp
            ret     4                 ; Navrat do hl. programu s vymazanim
                                      ; parametrov
Vypis       ENDP
;------------------------------------------------------------------------------;
Kladne      PROC    NEAR              ; Podprogram spocita vs. kladne cisla

            xor     ax, ax
            mov     bx, offset Cisla  ; bx obs. offset buffera, kt. obsahuje 
            xor     cx, cx            ; cisla
            mov     cl, Pocet         ; cx obsahuje pocet cisel
            xor     dx, dx
Hladaj_kladne:
            mov     dl, [bx]          ; Daj do dl cislo z buffera a zisti
            cmp     dl, 0             ; ci je kladne
            jl      Zaporne_cislo     ; Cislo je zaporne takze nas nezaujima
            add     ax, dx            ; Pridaj kladne cislo k ax (sucet)
Zaporne_cislo:
            inc     bx                ; Posun sa buffery dalej
            loop    Hladaj_kladne

            cmp     ax, 127           ; Je sucet vacsi ako 127
            jbe     Ziadne_Pretecenie ; Nie je tak nedoslo k preteceniu

            push    ax                ; Vypis ze doslo k preteceniu
            mov     ah, 09h
            mov     dx, offset Pretecenie
            int     21h
            pop     ax
Ziadne_Pretecenie:

            mov     si, 5             ; Prevod suctu na vypisatelnu formu
            mov     bl, 10            ; Budeme delit 10
Prevod_kladny:
            div     bl                ; Del sucet 10
            cmp     al, 0             ; ak je podiel 0 tak skonci prevod
            je      Prevod_Kl_Ok      
            add     ah, 30h           ; Preved zvysok v ah na znak
            mov     [Cislo+si], ah    ; Daj do pom. buffera ah
            xor     ah, ah            ; nuluj ah
            dec     si                ; zniz poziciu v pom. buffery
            jmp     Prevod_kladny     ; Prevadzaj dalej
Prevod_Kl_Ok:
            add     ah, 30h           ; Prevod je na konci, zapis posl. zvysok
            mov     [Cislo+si], ah    ; do pom. buffera

            mov     ah, 09h           ; Vypis "Sucet je: "
            mov     dx, offset Sucet_Kl
            int     21h

            mov     cx, 5             ; Vypisanie prevedeneho vysledku
            sub     cx, si            ; cx obsahuje pocet cifier cisla
            inc     cx
Vysledok_Kladny:

            mov     ah, 02h           ; Vypisaie znaku cisla
            mov     dl, [Cislo+si]
            int     21h
            inc     si                ; Posun v pom. buffery o jedna

            loop    Vysledok_Kladny   ; Vypisuj dalej pokial nie si na konci

            mov     ah, 08h           ; Caka na stlac. klavesy
            int     21h

            ret

Kladne      ENDP
;------------------------------------------------------------------------------;
Zaporne     PROC    NEAR              ; Podprogram spocita vs. zaporne cisla

            xor     ax, ax
            mov     bx, offset Cisla  ; bx obsahuje offset buffera, kt. obs.
            xor     cx, cx            ; nacitane cisla
            mov     cl, Pocet         ; cx obsahuje pocet cisle
            xor     dx, dx
Hladaj_zaporne:
            mov     dl, [bx]          ; daj do dl cislo z buffera a zisti
            cmp     dl, 0             ; ci je zaporne
            jge     Kladne_je_cislo   ; cislo je kladne tak nas nezaujima
            neg     dl                ; cislo je zaporne zober jeho abs. hodnotu
            add     ax, dx            ; pripocitaj cislo k suctu v ax
Kladne_je_cislo:
            inc     bx                ; posun sa v buffery o jedna
            loop    Hladaj_zaporne    ; hladaj dalej

            cmp     ax, 128           ; ak je sucet > 128 tak doslo k podteceniu
            jbe     Ziadne_Podtecenie

            push    ax                ; Napis spravu o podteceni
            mov     ah, 09h
            mov     dx, offset Podtecenie
            int     21h
            pop     ax
Ziadne_Podtecenie:

            mov     si, 5             ; Prevedenie vysledku na vypisatelnu podobu
            mov     bl, 10            ; Budeme delit 10
Prevod_zaporny:
            div     bl                ; Del sucet v ax 10
            cmp     al, 0             ; ak je podiel 0 tak je prevod hotovy
            je      Prevod_Zp_Ok
            add     ah, 30h           ; Sprav zo zvysku v ah znak
            mov     [Cislo+si], ah    ; Daj ah do pom. buffera
            xor     ah, ah            ; nuluj ah
            dec     si                ; posun v pm. buffery o jedna spat
            jmp     Prevod_zaporny    ; Prevadzaj dalej
Prevod_Zp_Ok:
            add     ah, 30h           ; Koniec prevodu, daj do pom. buffera
            mov     [Cislo+si], ah    ; posledny zvysok po deleni

            mov     ah, 09h           ; Vypise "Sucet je: -"
            mov     dx, offset Sucet_Zp
            int     21h

            mov     cx, 5             ; Vypisanie vysledku na obrazovku
            sub     cx, si            ; cx obsahuje pocet cifier cisla 
            inc     cx
Vysledok_Zaporny:

            mov     ah, 02h           ; Vypisanie znaku z pom. buffera
            mov     dl, [Cislo+si]
            int     21h
            inc     si

            loop    Vysledok_Zaporny  ; Vypis dalsi znak

            mov     ah, 08h           ; Caka na stlac. klavesy
            int     21h

            ret

Zaporne     ENDP
;------------------------------------------------------------------------------;
Max_Sort    PROC    NEAR              ; Podprogram usporiada cisla MAX Sortom

            mov     si, offset Cisla  ; Buffer cisle
            mov     di, offset Cisla_MAX ; Buffer uspor. cisel
            xor     cx, cx            ; cx obsahuje pocet cisel
            mov     cl, Pocet
            rep     movsb             ; Skopiruj cisla

            mov     di, offset Cisla_MAX ; Buffer uspor. cisel
            mov     si, offset Cisla_MAX ; -||-
            xor     dx, dx
            mov     dl, Pocet            ; dx obsahuje pocet usporaduvanych cis.
Sort:
            mov     cx, dx               ; daj do cx dx
            mov     al, [di]             ; daj do al prve cislo
            mov     bx, di               ; daj do bx poziciu cisla
Hladaj_max:
            cmp     al, [di]             ; porovnaj cislo v al s cislom v buff.
            jge     Je_vacsie            ; ak je cislo v buff. vacsie tak
            mov     bx, di               ; ho daj do al a jeho poziciu do bx
            mov     al, [di]
Je_vacsie:
            inc     di                   ; posun v buffery o jedna
            loop    Hladaj_max

            mov     ah, [si]             ; Vymen najdene max. s prvym cislom
            mov     [bx], ah
            mov     [si], al
            inc     si

            dec     dx                   ; Nastav sa za uz uspor. cisla
            sub     di, dx               ; a zmensi pocet usporaduvanych cisel

            cmp     dx, 0                ; Opakuj algoritmus
            je      Zosortovane
            jmp     Sort
Zosortovane:
            mov     ah, 09h              ; Napis "Usporiadane cisla: "
            mov     dx, offset Usporiadane
            int     21h

            mov     di, offset Zapisane
            mov     si, offset Cisla_MAX 
            xor     cx, cx
            mov     cl, Pocet
            mov     bl, 10
Prevod:
            mov     al, [si]
            cmp     al, 0
            jge     Je_Kladne

;            mov     bh, al
;            mov     ah, 02h
;            mov     dl, '-'
;            int     21h
;            mov     al, bh
            mov     byte ptr [di], '-'
            inc     di
            neg     al
Je_Kladne:
            cmp     al, 100
            jb      Menej_ako_sto

            sub     al, 100
;            mov     bh, al
;            mov     ah, 02h
;            mov     dl, '1'
;            int     21h
;            mov     al, bh
            mov     byte ptr [di], '1'
            inc     di
Menej_ako_sto:
            xor     ah, ah
            div     bl

            add     al, 30h
            add     ah, 30h

;            mov     bh, ah
;            mov     ah, 02h
;            mov     dl, al
;            int     21h
;            mov     ah, bh
            mov     byte ptr [di], al
            inc     di

;            mov     dl, ah
;            mov     ah, 02h
;            int     21h
            mov     byte ptr [di], ah
            inc     di

            cmp     cx, 1
            je      Bez_ciarky
;            mov     ah, 02h
;            mov     dl, ','
;            int     21h
            mov     byte ptr [di], ','
            inc     di
Bez_ciarky:
            inc     si
            loop    Prevod

            mov     bx, offset Zapisane ; Predanie parametrov podprogramu
            push    bx                ; Vypis pomocou zasobniku
            mov     bx, Dlzka         ; Dlzka - 1 lebo posledny znak
            push    bx
            call    Vypis             ; Vypis usporiadane udaje

            mov     ah, 3ch           ; Vytvor vystupny subor pre zapis
            mov     dx, offset Vystup
            xor     cx, cx
            int     21h
            
            mov     bx, ax            ; Zapis uspor. cisla do vystup. suboru
            mov     ah, 40h
            mov     dx, offset Zapisane
            mov     cx, Dlzka
            int     21h
            
            mov     ah, 08h           ; Caka na stlac. klavesy
            int     21h

            ret

Max_sort    ENDP
;------------------------------------------------------------------------------;
Delenie     PROC    NEAR              ; Podprogram vydeli dve vybrane cisla

            mov     si, offset Cisla  ; Buffer cisel
            xor     cx, cx
                                      ; Vypise vysvetlivku
            mov     ah, 09h           ; "Zvol prve cislo: "
            mov     dx, offset Zvol_1
            int     21h

            mov     ah, 01h           ; Nacitanie znaku s vypisom na obrazovku
            int     21h
            sub     al, 30h           ; Premena znaku na offset v buffery cis.
            xor     bx, bx
            mov     bl, al            ; bx je offset vzhlad. na zac. buffera
            mov     cl, [si + bx]     ; Ulozenie do cl prveho zvol. cisla

            mov     ah, 09h           ; Vypise "Zvol druhe cislo: "
            mov     dx, offset Zvol_2
            int     21h

            mov     ah, 01h           ; Nacitanie znaku s vypisom na obrazovku
            int     21h
            sub     al, 30h           ; Premena znaku na offset v buffery cis.
            xor     bx, bx
            mov     bl, al            ; bx je offset vzhlad. na zac. buffera
            mov     ch, [si + bx]     ; Ulozenie do ch druheho zvol. cisla

            mov     ah, 09h           ; Vypise "Podiel: "
            mov     dx, offset Podiel_1
            int     21h

            xor     bx, bx            ; Vypise prve cislo podprogramom Napis 
            mov     bl, cl
            push    bx
            call    Napis

            mov     ah, 09h           ; Vypise "/"
            mov     dx, offset Podiel_2
            int     21h

            xor     bx, bx            ; Vypise druhe cislo podprogramom Napis 
            mov     bl, ch
            push    bx
            call    Napis

            mov     ah, 09h           ; Vypise "="
            mov     dx, offset Podiel_3
            int     21h

            xor     ax, ax            ; Predpriprava registrov
            xor     bx, bx
            mov     al, cl            ; v ax je delenec
            mov     bl, ch            ; v bl je delitel

            xor     dx, dx            ; Zistenie znamienka podielu
            cmp     al, 0             ; Ak je delenec zaporny nastav priznak
            jge     Prve_kladne       ; a zober abs. hodnotu delenca
            neg     al                ; Zober abs. hodnotu delenca
            inc     dx                ; Nastavenie priznaku
Prve_kladne:
            cmp     bl, 0             ; Ak je delitel zaporny nastav priznak a
            jge     Druhe_kladne      ; zober jeho abs. hodnotu
            neg     bl                ; Zober abs. hodnotu delitela
            dec     dx                ; Nastav priznak
Druhe_kladne:
            div     bl                ; Vydel delenca delitelom

            cmp     dx, 0             ; Zisti znamienko podielu pomocou
            je      Kladny_podiel     ; predtym nastavenych priznakov
            push    ax
            mov     ah, 02h           ; Ak je podiel zaporny tak napis '-'
            mov     dl, '-'
            int     21h
            pop     ax
Kladny_podiel:

            xor     bx, bx            ; Vypis podiel pomocou podprogramu Napis
            mov     bl, al
            push    bx
            call    Napis

            push    ax                ; Vypise "Zvysok: "
            mov     ah, 09h
            mov     dx, offset Podiel_4
            int     21h
            pop     ax

            mov     bl, ah            ; Vypis zvysok pomocou podprogramu Napis
            push    bx
            call    Napis

            mov     ah, 08h           ; Caka na stlacenie klavesy
            int     21h

            ret

Delenie     ENDP
;------------------------------------------------------------------------------;
Napis       PROC    NEAR              ; Podprogram vypise cislo predane ako
                                      ; parameter na obrazovku
Co          EQU     [bp+4]

            push    bp                ; Pre pracu z parametrami ulozenymi
            mov     bp, sp            ; v zasobniku
            pusha                     ; Zachivanie pov. obsahu registrov

            mov     si, 5             ; Offset vshladom na zac. pom buffera
            mov     ax, Co            ; ax obsahuje cislo, kt. sa ma vypisat
            xor     ah, ah            ; Cislo je v rozsahu <-128,127>
            cmp     al, 0             ; takze je len v al
            jge     Kladne_Ciselko    ; Ak je zaporne vypise '-'

            push    ax                ; Vypise '-'
            mov     ah, 02h
            mov     dl, '-'
            int     21h
            pop     ax
            neg     al                ; Zober abs. hodnotu cisla

Kladne_Ciselko:
            mov     bl, 10            ; budeme delit 10
            div     bl                ; cislo del 10

            cmp     al, 0             ; ak je podiel 0 tak je prevod hotovy
            je      Prevod_Hotovo_2
            add     ah, 30h           ; preved zvysok v ah na znak
            mov     [Cislo+si], ah    ; daj do pom. buffera dany znak
            dec     si                ; posum v pom buffery
            xor     ah, ah            ; zrus zvysok v ah

            jmp     Kladne_Ciselko    ; Pokracuj v prevode
Prevod_Hotovo_2:
            add     ah, 30h           ; Daj posledny zvysok do pom. buffera
            mov     [Cislo+si], ah
                                      
            mov     cx, 5             ; Vypis prevedeneho cisla na obr.
            sub     cx, si            ; cx obsahuje pocet cifier cisla
            inc     cx
Vysledne_cislo:

            mov     ah, 02h           ; Vypis danu cifru z pom. buffera
            mov     dl, [Cislo+si]
            int     21h
            inc     si

            loop    Vysledne_cislo    ; Vypisuj do konca cisla

            popa                      ; Obnov registre
            pop     bp                ; Obnov bp
            ret     2                 ; Navrat s vymazanim 1 parametra

Napis       ENDP
;------------------------------------------------------------------------------;
Nasob_Posl  PROC    NEAR              ; Podprogram vynasobi dve posledne cisla

            mov     si, offset Cisla  ; si ukazuje na buffer cisel
            xor     bx, bx
            mov     bl, Pocet         ; bx obsahuje pocet cisel - 1
            dec     bx
            add     si, bx            ; posun sa v buffery na koniec

            xor     ax, ax            ; v ax resp. al je posledne cislo
            mov     al, [si]
            xor     bx, bx            ; v bx resp. bl je predposledne cislo
            mov     bl, [si - 1]

            xor     dx, dx            ; Znamienkovy priznak
            cmp     al, 0             ; ak je prve cislo zaporne
            jge     Znamienko_ost_1   ; zober jeho abs. hodnotu a nastav.
            dec     dx                ; znam. priznak
            neg     al
Znamienko_ost_1:
            cmp     bl, 0             ; ak je druhe cislo zaporne zober
            jge     Znamienko_ost_2   ; jeho abs. hodnotu a nastav znam. priz.
            inc     dx
            neg     bl
Znamienko_ost_2:
            mul     bl                ; vynasob tieto dve cisla

            cmp     dx, 0
            je      Sucin_je_kladny
            
            cmp     ax, 128           ; Vysledok je zaporny tak zisti ci doslo 
            jbe     V_rozsahu         ; k podteceniu
            push    ax
            mov     ah, 09h
            mov     dx, offset Podtecenie
            int     21h
            pop     ax
            jmp     V_rozsahu
Sucin_je_kladny:
            cmp     ax, 127           ; Vysledok je kladny tak zisti ci doslo
            jbe     V_rozsahu         ; k preteceniu
            push    ax
            mov     ah, 09h
            mov     dx, offset Pretecenie
            int     21h
            pop     ax
V_rozsahu:
            push    ax               ; Vypise "Vysledok je: "
            mov     ah, 09h
            mov     dx, offset Nasobene
            int     21h
            pop     ax

            cmp     dx, 0
            je      Kladny_Vysledok

            push    ax               ; Vysledok je zaporny tak napis "-"
            mov     ah, 02h
            mov     dl, '-'
            int     21h
            pop     ax

Kladny_Vysledok:
            mov     bl, 10
            div     bl               ; Del vysledok 10

            cmp     al, 0            ; Ak je podiel = 0 tak je prevod hotovy
            je      Prevod_Hotovo
            add     ah, 30h          ; Preved zvysok na znak
            mov     dl, ah           ; Daj do dl znak na vypis
            xor     ah, ah

            push    ax               ; Vypis cifru cisla
            mov     ah, 02h
            int     21h
            pop     ax

            jmp     Kladny_Vysledok
Prevod_Hotovo:
            add     ah, 30h          ; Vypis posledny zvysok po deleni
            mov     dl, ah           ; t.j. poslednu cifru cisla
            mov     ah, 02h
            int     21h

            mov     ah, 08h          ; Caka na stlac klavesy
            int     21h

            ret

Nasob_Posl  ENDP
;------------------------------------------------------------------------------;
CODE        ENDS
;******************************************************************************;
            END     Start
;******************************************************************************;
; Program je pri danom vstupnom subore funkcny. Program nekontroluje pri deleni
; dvoch zvolenych cisel spravnost volby cisel, t.j. ak uzivatel zvoli cislo 8
; a nacitanych cisel je len 7 tak nastane chyba.
; Program je rozdeleny do podprogramov z ktorych kazdy vykovana jednu z uloh,
; plus nejake pomocne podprogramy na vypis a prevod.
; Max. pocet cisel vo vstupnom subore je 10. A tieto cisla su 8 bitove, ich
; rozsah je <-128,127>. Program zobrazi spravny vysledok aj pri preteceni/pod-
; teceni s tym ze upozorni na tento stav.
; V programe su pouzite instrukcie pusha a popa preto je na zaciatku prepinac
; .286
; Ziadny z podprogramov nezachovava obsah vsetkych registrov.
; Program bol napisany v editore Volcov Commandera, a ladeny Turbo Debbugerom
; verzie 2.0
; Na usporiadanie cisel je pouzity algoritmus Max Sort. Delenie aj nasobenie
; je robene len s abs. hodnotami cisel s tym ze sa nastavuje znamienovy priznak.
; Pri nasobeni dvoch posl. cisel nastava divide overflow error ak su tieto
; dve cisla prilis velke resp. ich sucin
;******************************************************************************;