zas     segment stack
        dw      64 dup(?)
zas     ends
;------------------data segment---------------------
data    segment
MenoSuboru	db      "subor.txt",0
MenoVystupnehoSuboru db	"vystup.txt",0
ObsahSuboru	db      80 dup(?),'$'
DesiatkovaPostupnost db 150 dup(?),'$'
Postupnost	db	50 dup(?)
MonotonnaPostupnost db	50 dup(?), '$'
Ponuka		db	10,13,"a ... suma cisel",10,13,"b ... rastuce usporiadanie"
		db	10,13,"c ... klesajuce usporiadanie",10,13,"d ... delenie cisel"
		db	10,13,"e ... nasobenie cisel",10,13,"k ... koniec",10,13,'$'
Neotvoril       db      10,13,"Subor sa nepodarilo otvorit!$"
Nezatvoril      db      10,13,"Subor sa nepodarilo zatvorit!$"
ChybaPriCitani  db      10,13,"Nastala chyba pri citani zo suboru!$"
Dakujem		db	10,13,"Dakujem za pouzitie. Samuel Ferencik.",10,13,"     Pekny den.$"
VypisSumy	db	10,13,"Sucet cisel v subore je $"
Rastuca		db	10,13,"Nacitane cisla vo vzostupnom poradi:",10,13,'$'
Klesajuca	db	10,13,"Nacitane cisla v zostupnom poradi:",10,13,'$'
Pretecenie	db	10,13,"Operacia prekrocila povoleny ciselny rozsah -32768 ... 32767$"
Desat		dw	000Ah
NovyRiadok	db	10,13,'$'
PoradoveCislo	db	". ... $"
VyberPrve	db	10,13,"Vyber prve cislo: $"
VyberDruhe	db	10,13,"Vyber druhe cislo: $"
data    ends
;------------------kod programu---------------------
code    segment
        assume  cs:code, ss:zas, ds:data

;===============procedury==========
PROC	ErrorOpening			;Upozorni, ze subor sa nepodarilo otvorit
	mov     dx, offset Neotvoril
	mov     ah, 09h
	int     21h
	ret
ENDP	ErrorOpening

PROC	ErrorClosing			;Upozorni, ze subor sa nepodarilo zavriet
	mov     dx, offset Nezatvoril
	mov     ah, 09h
	int     21h
	ret
ENDP	ErrorClosing

PROC	ErrorReading			;Upozorni, ze nastala chyba pri citani
	mov     dx, offset ChybaPriCitani
	mov     ah, 09h
	int     21h
	ret
ENDP	ErrorReading

PROC	OpenOutputFile
        mov     dx, offset MenoVystupnehoSuboru
        mov     ax, 3D02h
        int     21h					;otvori subor
        jnc     OutputFileOpened
	call	ErrorOpening
OutputFileOpened:
	mov	bx, ax
	ret
ENDP	OpenOutputFile

PROC	CloseOutputFile
        mov     ah, 3Eh
        int     21h					;zavrie subor
        jnc	OutputFileClosed
	call    ErrorClosing
OutputFileClosed:
	ret
ENDP	CloseOutputFile

PROC	OutputBinaryToFile
	mov	ah, 40h
	mov	dx, offset DesiatkovaPostupnost
	mov	cx, 0000h
	ret
ENDP	OutputBinaryToFile

PROC	OutputBinary			;vypise binarne cislo (musi byt v AX) decimalne
	cmp	ax, 7FFFh
	jbe	CorrectPositive		;ak je kladne, pokracuje
	neg	ax			;ak je zaporne, vypise '-' a pokracuje
	push	ax
	mov	dl, '-'
	mov	ah, 02h
	int	21h
	mov	byte ptr[di], '-'
	inc	di
	pop	ax
 CorrectPositive:
	mov	cx, 0005h
	push	di
	mov	di, offset Desat
 FiveFoldDivision:
	xor	dx, dx
	div	word ptr[di]
	push	dx
	loop	FiveFoldDivision
	mov	cx, 0005h
	mov	ah, 02h
	mov	bp, sp
	mov	di, [bp+10]
 FiveFoldOutput:
	pop	dx
	add	dx, 0030h
	int	21h
	mov	byte ptr[di], dl
	inc	di
	loop	FiveFoldOutput
	mov	byte ptr[di], '$'
	pop	dx
	ret
ENDP	OutputBinary

PROC	SumAll				;Vypocita sumu vsetkych cisel
	push	bp
	mov	bp, sp
	mov	cx, [bp+4]				;do cx ulozi pocet cisel (pre cyklus scitavania)
	mov	di, offset Postupnost
	xor	ax, ax					;nuluje ax - tu ulozi sucet
 SummingCycle:
	mov	dh, [di]
	inc	di
	mov	dl, [di]
	inc	di					;do dx nacita cislo z Postupnosti
	add	ax, dx					;CONSIDER    ADD AX,[DI], DI+=2
	jo	SummingOverflow
	loop	SummingCycle				;cyklus - dalsie cislo

	push	ax
	mov	dx, offset VypisSumy
	mov	ah, 09h
	int	21h					;vypise: "Suma je "
	pop	ax
	call	OutputBinary
	jmp	SumReturn
 SummingOverflow:
	mov	dx, offset Pretecenie			;upozorni na pretecenie
	mov	ah, 09h
	int	21h
 SumReturn:
	pop	bp
	ret
ENDP	SumAll

PROC	CreateMonotone			;Usporiada nacitane cisla do klesajucej postupnosti
	mov	si, offset Postupnost			;si ukazuje na nasu postupnost cisel
	mov	bx, offset MonotonnaPostupnost		;bx ukazuje na tu, ktora bude monotonna
	push	bp
	mov	bp, sp
	mov	cx, [bp+4]				;do cx dame pocet cisel
 CopySeries:						;bez zmeny prekopiruje vsetky cisla
	mov	dx, [si]
	mov	[bx], dx
	add	si, 0002h
	add	bx, 0002h
	loop	CopySeries
	mov	cx, [bp+4]				;opat cx = pocet cisel
	dec	cx
	mov	si, offset MonotonnaPostupnost		;si ukazuje na MonotonnuPostupnost
 FindNextMinimum:					;usporiada NonotonnuPostupnost
	mov	dx, 0001h
	mov	di, 0000h
 CompareNext:						;hlada najmensi prvok z MP
	mov	bx, si					;ked ho najde, bude nan ukazovat di
	add	bx, di
	add	bx, di
	mov	ah, [bx]
	inc	bx
	mov	al, [bx]
	mov	bx, si
	add	bx, dx
	add	bx, dx
	push	ax
	mov	ah, [bx]
	inc	bx
	mov	al, [bx]
	mov	bx, ax
	pop	ax
	add	ax, 8000h				;pri porovnavani prida k cislam
	add	bx, 8000h				;8080h, aby zaporne bolo mensie
	cmp	bx, ax					;ako kladne
	jnb	NotSmaller
	mov	di, dx					;ak nasiel mensi, presunie nan di
 NotSmaller:
	inc	dx
	cmp	dx, cx
	jbe	CompareNext				;porovnava dalsie dva
	mov	bx, si					;najmensi prvok da na poslednu
	add	bx, di					;poziciu
	add	bx, di
	mov	dx, [bx]
	mov	bx, si
	add	bx, cx
	add	bx, cx
	mov	ax, [bx]
	mov	bx, si					;z poslednej pozicie da prvok tam,
	add	bx, cx					;skade zobral najmensi
	add	bx, cx
	mov	[bx], dx
	mov	bx, si
	add	bx, di
	add	bx, di
	mov	[bx], ax
	loop	FindNextMinimum				;hlada dalsi najmensi prvok, aby
	pop	bp					;zaradit na koniec MP
	ret
ENDP	CreateMonotone

PROC	Increasing			;odzadu vypise MonotonnuPostupnost (ta je klesajuca)
	push	bp
	mov	bp, sp
	mov	cx, [bp+4]				;cx = pocet cisel
	push	ax
	push	dx
	mov	di, offset DesiatkovaPostupnost
	call	OpenOutputFile				;otvori vystup.txt a file handle -> bx
	mov	dl, bl
	mov	ah, 02h
	int	21h
	pop	dx
	pop	ax
	push	bx					;file handle -> zasobnik
	mov	si, offset MonotonnaPostupnost
	add	si, cx
	add	si, cx					;nastavi si na koniec MP
	mov	dx, offset Rastuca
	mov	ah, 09h
	int	21h					;vypise "Vzostupne poradie: "
 OutputIncreasing:					;v cykle vypise cisla
	sub	si, 0002h
	mov	ah, [si]
	mov	al, [si+1]
	pop	bx					;z vrcholu zasobnika vezme bx; ten bude pouzivat v OutputBinaryFile
	push	cx
	call	OutputBinary				;OB vypisuje binarne cislo decimalne
	pop	cx
	push	bx					;bx je znova na vrchole zasobnika
	mov	dl, ','					;oddeluje ciarkami
	mov	ah, 02h
	int	21h
	loop	OutputIncreasing
	pop	bx					;zoberie file handle zo zasobnika
	call	OutputBinaryToFile
	call	CloseOutputFile				;predpoklada, ze v bx je file handle
	pop	bp
	ret
ENDP	Increasing

PROC	Decreasing			;vypisuje MonotonnuPostupnost odpredu; ostatne ako
	push	bp			;pri procedure Increasing
	mov	bp, sp
	mov	cx, [bp+4]
	mov	si, offset MonotonnaPostupnost
	mov	dx, offset Klesajuca
	mov	ah, 09h
	int	21h
 OutputDecreasing:
	mov	ah, [si]
	mov	al, [si+1]
	push	cx
	call	OutputBinary
	pop	cx
	mov	dl, ','
	mov	ah, 02h
	int	21h
	add	si, 0002h
	loop	OutputDecreasing
	pop	bp
	ret
ENDP	Decreasing

PROC	SelectTwo			;vypyta si indexy dvoch cisel
	push	bp
	mov	bp, sp
	mov	cx, [bp+4]
	mov	si, offset Postupnost
	mov	bx, 0001h
 OutputAll:
	mov	dx, offset NovyRiadok
	mov	ah, 09h
	int	21h					;odriadkuje
	mov	ax, bx					;index cisla z bx do ax
	aam
	add	ax, 3030h
	push	ax
	mov	dl, ah
	mov	ah, 02h
	int	21h
	pop	ax
	mov	dl, al
	mov	ah, 02h
	int	21h					;vypise poradove cislo vypisovaneho
	mov	dx, offset PoradoveCislo
	mov	ah, 09h
	int	21h					;vypise ". ... " (vizualizacia)
	mov	ah, [si]
	mov	al, [si+1]
	push	bx
	push	cx
	call	OutputBinary				;vypise bx-te cislo
	pop	cx
	pop	bx
	inc	bx					;zvysi bx
	add	si, 0002h				;posunie si na dalsie cislo
	loop	OutputAll				;a znova...

	mov	dx, offset VyberPrve
	mov	ah, 09h
	int	21h					;vyzve k vyberu 1. cisla
	mov	ah, 01h
	int	21h
	mov	bh, al
	int	21h					;nacita ho po znakoch
	mov	bl, al
	push	bx
	mov	dx, offset VyberDruhe
	mov	ah, 09h
	int	21h					;vyzve k vyberu 2. cisla
	mov	ah, 01h
	int	21h
	mov	bh, al
	int	21h					;nacita po znakoch
	mov	bl, al
	pop	ax					;prve da do ax
	push	bx					;druhe da do zasobnika

	sub	ax, 3030h				;1. cislo prevedie do binarnej formy
	mov	bx, ax
	mov	dl, 0Ah
	mov	al, ah
	mov	ah, 00h
	mul	dl
	mov	bh, 00h
	add	ax, bx
	pop	bx
	push	ax					;cislo 1 ulozi do zasobnika
	mov	ax, bx
	sub	ax, 3030h				;2. cislo do binarnej formy
	mov	bx, ax
	mov	dl, 0Ah
	mov	al, ah
	mov	ah, 00h
	mul	dl
	mov	bh, 00h
	add	ax, bx
	pop	bx					;cislo 1 presunie zo zasobnika do bx
	push	ax					;cislo 2 ulozi do zasobnika

	mov	dx, offset NovyRiadok
	mov	ah, 09h
	int	21h					;odriadkuje
	dec	bx
	mov	si, offset Postupnost
	add	si, bx
	add	si, bx					;nastavi si na bx-ty prvok Postupnosti
	mov	ah, [si]
	mov	al, [si+1]				;prve cislo ulozi do ax
	push	ax					;...a do zasobnika
	call	OutputBinary				;vypise ax
	mov	dx, 00F8h
	mov	ah, 02h
	int	21h					;vypise nasobenie
	pop	ax
	pop	bx					;zo zasobnika vyberie druhe (neupravene) cislo
	push	ax					;prve (uz upravene) da naspat na zas.
	dec	bx
	mov	si, offset Postupnost
	add	si, bx
	add	si, bx					;nastavi si na druhe cislo
	mov	ah, [si]
	mov	al, [si+1]
	push	ax					;druhe cislo (upravene) tiez do zasobnika
	call	OutputBinary				;vypise druhe cislo
	mov	dl, '='					;vypise '='
	mov	ah, 02h
	int	21h					;vypise rovnost
							;vypis je hotovy, nasleduje aritmetika
	pop	bx
	pop	ax
	pop	bp
	ret
ENDP	SelectTwo

PROC	Multiplication			;vynasobi dve cisla v ax, bx
	push	bx					;druhe cislo do zas.
	mov	bx, 0000h
	cmp	ax, 7FFFh
	jbe	FirstMultiplePositive			;skontroluje, ci je prve cislo >=0
	neg	ax					;ak nie, zneguje ho
	mov	bx, 0001h				;a zapamata si prvy minus
FirstMultiplePositive:
	mov	dx, ax					;abs hodnotu cisla presunie do dx
	pop	ax					;druhe cislo do ax
	cmp	ax, 7FFFh				;podobne sa postara o znamienko 2. cisla
	jbe	SecondMultiplePositive
	neg	ax
	add	bx, 0001h
SecondMultiplePositive:
	sub	bx, 0001h				;bx je z {0,1,2}
	jnz	MultiplePositive			;bx-1=0 <=> vysledok je zaporny
	push	dx
	push	ax
	mov	dl, '-'
	mov	ah, 02h
	int	21h					;ak je vysledok <0, vypise minus
	pop	ax
	pop	dx
MultiplePositive:
	mov	bx, ax					;druhe cislo do bx
	mov	ax, dx					;prve do ax - bude sa nasobit
	mov	dx, 0000h
	mul	bx					;prve * druhe
	jo	MultiplyingOverflow
	call	OutputBinary				;ak vysledok pretiekol, upozorni
	jmp	MultiplicationDone
MultiplyingOverflow:
	mov	dx, offset Pretecenie
	mov	ah, 09h
	int	21h
MultiplicationDone:
	ret
ENDP	Multiplication

PROC	Division			;vynasobi dve cisla v ax, bx
	push	bx					;druhe cislo (delitel) do zas.
	mov	bx, 0000h
	cmp	ax, 7FFFh
	jbe	DividendPositive			;skontroluje, ci je delenec >=0
	neg	ax					;ak nie, zneguje ho
	mov	bx, 0001h				;a zapamata si prvy minus
DividendPositive:
	mov	dx, ax					;abs hodnotu cisla presunie do dx
	pop	ax					;delitel do ax
	cmp	ax, 7FFFh				;podobne sa postara o znamienko delitela
	jbe	DivisorPositive
	neg	ax
	add	bx, 0001h
DivisorPositive:
	sub	bx, 0001h				;bx je z {0,1,2}
	jnz	QuotientPositive			;bx-1=0 <=> vysledok je zaporny
	push	dx
	push	ax
	mov	dl, '-'
	mov	ah, 02h
	int	21h					;ak je vysledok <0, vypise minus
	pop	ax
	pop	dx
QuotientPositive:
	mov	bx, ax					;delitel cislo do bx
	mov	ax, dx					;delenec do ax - bude sa delit
	mov	dx, 0000h
	div	bx					;delenec/delitel
	jo	DividingOverflow
	call	OutputBinary				;ak vysledok pretiekol, upozorni
	jmp	DivisionionDone
DividingOverflow:
	mov	dx, offset Pretecenie
	mov	ah, 09h
	int	21h
DivisionionDone:
	ret
ENDP	Division
;=======================================================
;===============hlavny program==========================
;=======================================================
START:  mov     ax, seg data
        mov     ds, ax

;-----praca so suborom - otvori, nacita, zavrie
        mov     dx, offset MenoSuboru
        mov     ax, 3D00h
        int     21h					;otvori subor
        jnc     FileOpened
	call	ErrorOpening
	jmp	TheEnd
FileOpened:
        mov     bx, ax					;Handle->BX
        push    bx
        mov     dx, offset ObsahSuboru
        mov     cx, 80
        mov     ah, 3Fh					;nacita obsah suboru do ObsahSuboru
        int     21h
	push	ax
	jnc     FileRead
	call	ErrorReading
	jmp	TheEnd
FileRead:
	pop	ax
        pop     bx
	push	ax
        mov     ah, 3Eh
        int     21h					;zavrie subor
        jnc	FileClosed
	call    ErrorClosing
	jmp	TheEnd
FileClosed:
	pop	cx
	mov	bx, offset ObsahSuboru					;bx nastavi na zaciatok nacitaneho
	mov	si, offset Postupnost			;si nastavi tam, kde chce ukladat konvertovane cisla
	xor	ax, ax					;nuluje AX

;-----nacitanie zo suboru a ulozenie do datoveho registra
Conversion:						;konverzia z desiatkovej sustavy na
	mov	dl, [bx]				;binarny doplnkovy kod
	cmp	dl, '-'					;obsah bx -> dl
	jnz	NotMinus
	mov	dh, 01h					;ak nacital '-', nastavi dh na
	inc	bx					;hodnotu 1
	loop	Conversion				;pokracuje
	jmp	ConversionDone
 NotMinus:
	cmp	dl, '0'
	jb	EndOfNumber
	cmp	dl, '9'
	ja	EndOfNumber				;ak nenacital cifru, skoci na zapis
	push	dx
	mov	dx, 000Ah
	mul	dx					;sucet (v ax) nasobi *10
	pop	dx
	sub	dl, 30h					;znak cifry upravi na jej hodnotu
	push	dx
	mov	dh, 00h
	add	ax, dx					;pripocita k suctu (na miesto jednotiek)
	pop	dx
	inc	bx					;posunie na dalsi prvok,
	mov	dl, [bx]				;ktory nasledne nacita
	loop	NotMinus				;predpoklada, ze dalsi znak nie je -
	inc	cx					;ak nacitany znak bol posledny, potom cx = 0. Lenze treba este cislo zapisat a tak nechame cx = 1
 EndOfNumber:						;sem skoci, ak nasiel znak iny ako cifru
	cmp	ax, 0000h				;ak je cislo = 0, nebude ho zapisovat
	jz	Skip
	cmp	dh, 00h					;ak bolo kladne, nerobi doplnok
	jz	Positive
	neg	ax
  Positive:
	xor	dx, dx					;nuluje dx pre dalsiu pracu
	mov	[si], ah				;zapise prvy byte
	inc	si
	mov	[si], al				;zapise druhy byte
	inc	si
	xor	ax, ax					;nuluje ax pre dalsiu pracu
  Skip:
	inc	bx					;zvysi bx a pokracuje
	loop	Conversion
;	jmp	ConversionDone

ConversionDone:
	mov	byte ptr[si], '$'			
	sub	si, offset Postupnost
	mov	ax, si					;v ax je pocet cifier v Postupnosti
	mov	dl, 02h
	div	dl					;vypocita pocet nacitanych cisel
	push	ax					;ulozi do zasobnika			
;-----vypis ponuky a vyber
Menu:
	mov	dx, offset Ponuka
	mov	ah, 09h
	int	21h					;vypise Ponuku
MenuChoice:
	mov	ah, 01h
	int	21h					;nacita vyber a vola prislusnu proceduru
	cmp	al, 'a'					;na vrchole zasobnika je pocet cisel v subore
	jnz	M1
	call	SumAll
	jmp	Menu
M1:
	cmp	al, 'b'
	jnz	M2
	call	CreateMonotone				;vytvori z Postupnosti MonotonnuPostupnost
	call	Increasing				;vypise prvky MP odzadu (rastuco)
	jmp	Menu
M2:
	cmp	al, 'c'
	jnz	M3
	call	CreateMonotone				;vytvori z Postupnosti MonotonnuPostupnost
	call	Decreasing				;vypise prvky MP (klesajuco)
	jmp	Menu
M3:
	cmp	al, 'd'
	jnz	M4
	call	SelectTwo
	call	Division
	jmp	Menu
M4:
	cmp	al, 'e'
	jnz	M5
	call	SelectTwo
	call	Multiplication
	jmp	Menu
M5:	
	cmp	al, 'k'
	jz	TheEnd
	mov	dl, 08h
	mov	ah, 02h
	int	21h
	jmp	MenuChoice

;-------koniec programu
TheEnd:
	mov	dx, offset Dakujem
        mov	ah, 09h
	int	21h
	mov	ah, 01h
	int	21h
	mov     ax, 4C00h
        int     21h
code    ends
        end     START